class Sketch extends Scheme{ // liikmeteks ainult harud
    //Branch parent;
    
    Sketch(byte t, Branch br, BaseLanguage bl, View v){ // konstruktor
	super(t, bl, v);
	parent = null; insert(br, 0);
    }
    
    // ylemklassi meetodite realisatsioonid --------------------------- 
    // meetodid liikmetega
    void insert(PrimitiveMember pm, int i){ // lisada lihtliige
	System.out.println
	    ("Sketch: illegal attempt to insert primitive member!");
	System.exit(0); 
    }
    void insert(Sketch sk, int i){ // lisada alamskeem
	System.out.println
	    ("Sketch: illegal attempt to insert subsketch!");
	System.exit(0);
    }
    void insert(Branch br, int i){ // lisada haru
	br.parent = this;
	body.insertElementAt(br, i);
    }
    void removeMember(int i){ // eemaldada i-s liige
	if(isMono()){
	    System.out.println
	    ("Sketch: illegal attempt to remove the single branch!");
	    System.exit(0);
	}
	body.removeElementAt(i);
    }
    
    // taseme leidmine
    int level(){
	if(parent == null) return 0;
	return parent.level() + 1;
    }
    
    // omameetodid ----------------------------------------------------
    boolean isMono(){
	return body.size() == 1;
    } 
    
}