import java.awt.*;
import java.util.*;
abstract class View extends Rectangle{
// ylemklass ko~ikidele vaadetele

    // tunnused meetodile adjust
    static final int INSERT = 0;
    static final int DELETE = 1;
    
   Graphics g; // graafikakontekst
   
   // planeerida skeem sk alates kohast (x, y)
   abstract void plan(Sketch sk, int x, int y);
   // planeerida haru br alates kohast (x, y)
   abstract void plan(Branch br, int x, int y);
   // joonistada graafikakonteksti g planeeritud skeem sk:
   abstract void draw(Sketch sk);
   // joonistada graafikakonteksti g planeeritud haru br:
   abstract void draw(Branch br);
   // arvestada muudatus reas/tekstis o, lisatud/eemaldatud:tag, kohal i
   abstract void adjust(Object o, int tag, int i);
   // kustutada valitu tunnused
   abstract void unpaintSelection();
    // panna valitu tunnused
   abstract void repaintSelection();
    // leida va"him alamskeem, kus asub antud punkt
   abstract boolean pointLocation(Point p, Scheme s);
	// tagastab false, kui (kasutaja poolt osutatud) p ei asu skeemis s
	// vastasel korral tagastab true, 
	// olles seadnud kursori View.caret
	// pyytakse leida va"him (alam)skeem, kuhu punkt kuulub
	// erijuhul jaa"b kursor skeemijoone alale 
	// globaalne: finish (p.o. eelnevalt false)
   static boolean finish; // meetodi pointLocation jaoks globaalne
   static Cursor result; // meetodi pointLocation jaoks globaalne	
   	
    boolean pointLocation(Point p, Row r){
	// reas (kommentaaris) otsimine
	if(r.contains(p)){
	    View.result.row = r;
	    return true;
	}
	return false;
    }//pointLocation(Point p, Row r)
    
     boolean pointLocation(Point p, Text t){
	// tekstis otsimine
	for(Enumeration e = t.rows.elements(); e.hasMoreElements();){
	    if(pointLocation(p, ((Row)(e.nextElement())))){
		result.text = t;
		return true;
	    }
	}//for
	// veel teksti kommentaaris:
	 if(pointLocation(p, t.comment)){
	    View.result.text = null;
	    View.result.row = t.comment;
	    return true;
	}
	return false;
    }//pointLocation(Point p, Text t)
    
     boolean pointLocation(Point p, Primitive pr){
	// primitiivis otsimine
	 if(pointLocation(p, pr.text)){
	    View.result.primitive = pr;
	    return true;
	 }
	 return false;
    }
} 